## verilator 5.042

=== CMakeLists.txt ===
#*****************************************************************************
#
# DESCRIPTION: Script for build tool cmake on both unix and windows
#
#*****************************************************************************
#
# Copyright 2003-2025 by Wilson Snyder. This program is free software; you
# can redistribute it and/or modify it under the terms of either the GNU
# Lesser General Public License Version 3 or the Perl Artistic License
# Version 2.0.
# SPDX-License-Identifier: LGPL-3.0-only OR Artistic-2.0
#
#****************************************************************************/

cmake_minimum_required(VERSION 3.15)
cmake_policy(SET CMP0091 NEW) # Use MSVC_RUNTIME_LIBRARY to select the runtime
project(
    Verilator
    VERSION 5.042
    HOMEPAGE_URL https://verilator.org
    LANGUAGES CXX
)

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build type" FORCE)
endif()

option(
    DEBUG_AND_RELEASE_AND_COVERAGE
    "Builds both the debug and release binaries, overriding CMAKE_BUILD_TYPE. Not supported under MSBuild."
)

find_package(Python3 COMPONENTS Interpreter)
set(PYTHON3 ${Python3_EXECUTABLE})
# See also CMake built-in; CMAKE_INSTALL_PREFIX is applied by the install command.
set(CMAKE_INSTALL_DATADIR .)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(CheckStructHasMember)
include(ExternalProject)
include(FindThreads)

if(NOT WIN32)
    message(WARNING "CMake support on Linux/OSX is experimental.")
endif()

if(WIN32)
    if(DEFINED ENV{WIN_FLEX_BISON})
        set(WIN_FLEX_BISON "$ENV{WIN_FLEX_BISON}")
    endif()
    if(IS_DIRECTORY ${WIN_FLEX_BISON})
        list(APPEND CMAKE_PREFIX_PATH ${WIN_FLEX_BISON})
    else()
        message(
            FATAL_ERROR
            "The path specified by WIN_FLEX_BISON environment variable is not an existing folder: ${WIN_FLEX_BISON}"
        )
    endif()
    if(NOT WIN_FLEX_BISON)
        message(
            FATAL_ERROR
            "Please install https://github.com/lexxmark/winflexbison and set WIN_FLEX_BISON environment variable. Please use install cmake target after a successful build."
        )
    endif()
    set(CMAKE_CXX_STANDARD 20)
endif()

set(OBJCACHE "" CACHE STRING "Path for ccache, auto-detected if empty")
option(OBJCACHE_ENABLED "Compile Verilator with ccache" ON)

if(OBJCACHE_ENABLED)
    if(OBJCACHE STREQUAL "")
        find_program(OBJCACHE_PATH ccache)
        if(OBJCACHE_PATH STREQUAL "OBJCACHE_PATH-NOTFOUND")
            set(OBJCACHE_PATH "")
        endif()
    else()
        set(OBJCACHE_PATH "${OBJCACHE}")
    endif()
    if(NOT OBJCACHE_PATH STREQUAL "")
        execute_process(
            COMMAND "${OBJCACHE_PATH}" --version
            OUTPUT_VARIABLE objcache_version
        )
        string(REGEX MATCH "[^\n\r]+" objcache_version "${objcache_version}")
        message(
            STATUS
            "Found ccache: ${OBJCACHE_PATH} (\"${objcache_version}\")"
        )
        set(CMAKE_CXX_COMPILER_LAUNCHER "${OBJCACHE_PATH}")
    endif()
endif()

find_package(BISON)
find_package(FLEX)

# Build
#set_property(GLOBAL PROPERTY JOB_POOLS one_job=1)

if(DEBUG_AND_RELEASE_AND_COVERAGE)
    if(CMAKE_GENERATOR MATCHES "^Visual Studio ")
        error("%Error: The DEBUG_AND_RELEASE_AND_COVERAGE option is not supported in MSBuild-based builds.")
    endif()
    set(saved_build_type ${CMAKE_BUILD_TYPE})
    set(CMAKE_BUILD_TYPE Debug)
    add_subdirectory(src build-Debug)
    set(CMAKE_BUILD_TYPE Release)
    add_subdirectory(src build-Release)
    set(CMAKE_BUILD_TYPE Coverage)
    add_subdirectory(src build-Coverage)
    set(CMAKE_BUILD_TYPE ${saved_build_type})
else()
    add_subdirectory(src)
endif()

# Configuration and Installation

set(PACKAGE_NAME ${PROJECT_NAME})
set(PACKAGE_VERSION ${PROJECT_VERSION})
set(CXX ${CMAKE_CXX_COMPILER})
set(AR ${CMAKE_AR})

configure_file(include/verilated_config.h.in include/verilated_config.h @ONLY)
configure_file(include/verilated.mk.in include/verilated.mk @ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/include/verilated_config.h
    DESTINATION include
)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/include/verilated.mk
    DESTINATION include
)

configure_package_config_file(
    verilator-config.cmake.in
    verilator-config.cmake
    INSTALL_DESTINATION .
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/verilator-config.cmake DESTINATION .)

configure_package_config_file(
    verilator-config-version.cmake.in
    verilator-config-version.cmake
    INSTALL_DESTINATION .
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/verilator-config-version.cmake
    DESTINATION .
)

foreach(
    program
    verilator
    verilator_gantt
    verilator_ccache_report
    verilator_difftree
    verilator_profcfunc
    verilator_includer
)
    install(PROGRAMS bin/${program} TYPE BIN)
endforeach()

install(
    DIRECTORY examples
    TYPE DATA
    FILES_MATCHING
    PATTERN "examples/*/*.[chv]*"
    PATTERN "examples/*/Makefile*"
    PATTERN "examples/*/CMakeLists.txt"
)

install(
    DIRECTORY include
    TYPE DATA
    FILES_MATCHING
    PATTERN "include/verilated_config.h"
    PATTERN "include/*.[chv]"
    PATTERN "include/*.cpp"
    PATTERN "include/*.vlt"
    PATTERN "include/*.sv"
    PATTERN "include/gtkwave/*.[chv]*"
    PATTERN "include/vltstd/*.[chv]*"
)

=== src/CMakeLists.txt ===
#*****************************************************************************
#
# DESCRIPTION: Script for build tool cmake on both unix and windows
#
#*****************************************************************************
#
# Copyright 2003-2025 by Wilson Snyder. This program is free software; you
# can redistribute it and/or modify it under the terms of either the GNU
# Lesser General Public License Version 3 or the Perl Artistic License
# Version 2.0.
# SPDX-License-Identifier: LGPL-3.0-only OR Artistic-2.0
#
#****************************************************************************/

#
# Utilities
macro(addBuildType sourceConfig newConfig)
    get_cmake_property(variableNames VARIABLES)
    foreach(variableName ${variableNames})
        if(variableName MATCHES "^CMAKE_.*_${sourceConfig}(|_.*)$")
            string(
                REPLACE
                _${sourceConfig}
                _${newConfig}
                newVariableName
                ${variableName}
            )
            set(${newVariableName} ${${variableName}})
            mark_as_advanced(${newVariableName})
            message(
                DEBUG
                "   Propagating ${variableName} to ${newVariableName} = ${${newVariableName}}"
            )
        endif()
    endforeach()
endmacro()

#
# Sources and headers for the verilator binary

set(HEADERS
    V3Active.h
    V3ActiveTop.h
    V3Assert.h
    V3AssertPre.h
    V3Ast.h
    V3AstAttr.h
    V3AstInlines.h
    V3AstNodeDType.h
    V3AstNodeExpr.h
    V3AstNodeOther.h
    V3AstNodeStmt.h
    V3AstUserAllocator.h
    V3Begin.h
    V3Branch.h
    V3Broken.h
    V3CCtors.h
    V3CUse.h
    V3Case.h
    V3Cast.h
    V3Cfg.h
    V3Class.h
    V3Clean.h
    V3Clock.h
    V3Combine.h
    V3Common.h
    V3Control.h
    V3Const.h
    V3Coverage.h
    V3CoverageJoin.h
    V3Dead.h
    V3Delayed.h
    V3Depth.h
    V3DepthBlock.h
    V3Descope.h
    V3Dfg.h
    V3DfgCache.h
    V3DfgContext.h
    V3DfgDataType.h
    V3DfgOptimizer.h
    V3DfgPasses.h
    V3DfgPatternStats.h
    V3DfgPeepholePatterns.h
    V3DfgVertices.h
    V3DiagSarif.h
    V3DupFinder.h
    V3EmitC.h
    V3EmitCBase.h
    V3EmitCConstInit.h
    V3EmitCFunc.h
    V3EmitCMain.h
    V3EmitCMake.h
    V3EmitMk.h
    V3EmitMkJson.h
    V3EmitV.h
    V3EmitXml.h
    V3Error.h
    V3ExecGraph.h
    V3Expand.h
    V3File.h
    V3FileLine.h
    V3Force.h
    V3Fork.h
    V3FuncOpt.h
    V3FunctionTraits.h
    V3Gate.h
    V3Global.h
    V3Graph.h
    V3GraphAlg.h
    V3GraphPathChecker.h
    V3GraphStream.h
    V3Hash.h
    V3Hasher.h
    V3HierBlock.h
    V3Inline.h
    V3Inst.h
    V3InstrCount.h
    V3Interface.h
    V3LangCode.h
    V3LanguageWords.h
    V3Life.h
    V3LifePost.h
    V3LinkCells.h
    V3LinkDot.h
    V3LinkInc.h
    V3LinkJump.h
    V3LinkLValue.h
    V3LinkLevel.h
    V3LinkParse.h
    V3LinkResolve.h
    V3List.h
    V3Localize.h
    V3MemberMap.h
    V3MergeCond.h
    V3Mutex.h
    V3Name.h
    V3Name.h
    V3Number.h
    V3OptionParser.h
    V3Options.h
    V3Order.h
    V3OrderGraph.h
    V3OrderInternal.h
    V3OrderMoveGraph.h
    V3Os.h
    V3PairingHeap.h
    V3Param.h
    V3Parse.h
    V3ParseImp.h
    V3PchAstMT.h
    V3PchAstNoMT.h
    V3PreExpr.h
    V3PreLex.h
    V3PreProc.h
    V3PreShell.h
    V3Premit.h
    V3ProtectLib.h
    V3Randomize.h
    V3Reloop.h
    V3Rtti.h
    V3Sampled.h
    V3Sched.h
    V3Scope.h
    V3Scoreboard.h
    V3SenExprBuilder.h
    V3SenTree.h
    V3Simulate.h
    V3Slice.h
    V3Split.h
    V3SplitAs.h
    V3SplitVar.h
    V3StackCount.h
    V3Stats.h
    V3StdFuture.h
    V3String.h
    V3Subst.h
    V3SymTable.h
    V3TSP.h
    V3Table.h
    V3Task.h
    V3ThreadPool.h
    V3Timing.h
    V3Trace.h
    V3TraceDecl.h
    V3Tristate.h
    V3Udp.h
    V3Undriven.h
    V3UniqueNames.h
    V3Unknown.h
    V3Unroll.h
    V3VariableOrder.h
    V3Waiver.h
    V3Width.h
    V3WidthCommit.h
    V3WidthRemove.h
    VlcBucket.h
    VlcOptions.h
    VlcPoint.h
    VlcSource.h
    VlcTest.h
    VlcTop.h
)

set(COMMON_SOURCES
    Verilator.cpp
    V3Active.cpp
    V3ActiveTop.cpp
    V3Assert.cpp
    V3AssertPre.cpp
    V3Ast.cpp
    V3AstNodes.cpp
    V3Begin.cpp
    V3Branch.cpp
    V3Broken.cpp
    V3CCtors.cpp
    V3CUse.cpp
    V3Case.cpp
    V3Cast.cpp
    V3Cfg.cpp
    V3CfgBuilder.cpp
    V3CfgLiveVariables.cpp
    V3Class.cpp
    V3Clean.cpp
    V3Clock.cpp
    V3Combine.cpp
    V3Common.cpp
    V3Control.cpp
    V3Const__gen.cpp
    V3Coverage.cpp
    V3CoverageJoin.cpp
    V3Dead.cpp
    V3Delayed.cpp
    V3Depth.cpp
    V3DepthBlock.cpp
    V3Descope.cpp
    V3Dfg.cpp
    V3DfgAstToDfg.cpp
    V3DfgBreakCycles.cpp
    V3DfgCache.cpp
    V3DfgColorSCCs.cpp
    V3DfgCse.cpp
    V3DfgDataType.cpp
    V3DfgDecomposition.cpp
    V3DfgDfgToAst.cpp
    V3DfgOptimizer.cpp
    V3DfgPasses.cpp
    V3DfgPeephole.cpp
    V3DfgRegularize.cpp
    V3DfgSynthesize.cpp
    V3DiagSarif.cpp
    V3DupFinder.cpp
    V3EmitCBase.cpp
    V3EmitCConstPool.cpp
    V3EmitCFunc.cpp
    V3EmitCHeaders.cpp
    V3EmitCImp.cpp
    V3EmitCInlines.cpp
    V3EmitCMain.cpp
    V3EmitCMake.cpp
    V3EmitCModel.cpp
    V3EmitCPch.cpp
    V3EmitCSyms.cpp
    V3EmitMk.cpp
    V3EmitMkJson.cpp
    V3EmitV.cpp
    V3EmitXml.cpp
    V3Error.cpp
    V3ExecGraph.cpp
    V3Expand.cpp
    V3File.cpp
    V3FileLine.cpp
    V3Force.cpp
    V3Fork.cpp
    V3FuncOpt.cpp
    V3Gate.cpp
    V3Global.cpp
    V3Graph.cpp
    V3GraphAcyc.cpp
    V3GraphAlg.cpp
    V3GraphPathChecker.cpp
    V3GraphTest.cpp
    V3Hash.cpp
    V3Hasher.cpp
    V3HierBlock.cpp
    V3Inline.cpp
    V3Inst.cpp
    V3InstrCount.cpp
    V3Interface.cpp
    V3Life.cpp
    V3LifePost.cpp
    V3LinkCells.cpp
    V3LinkDot.cpp
    V3LinkInc.cpp
    V3LinkJump.cpp
    V3LinkLValue.cpp
    V3LinkLevel.cpp
    V3LinkParse.cpp
    V3LinkResolve.cpp
    V3Localize.cpp
    V3MergeCond.cpp
    V3Name.cpp
    V3Number.cpp
    V3OptionParser.cpp
    V3Options.cpp
    V3Order.cpp
    V3OrderGraphBuilder.cpp
    V3OrderMoveGraph.cpp
    V3OrderParallel.cpp
    V3OrderProcessDomains.cpp
    V3OrderSerial.cpp
    V3Os.cpp
    V3Param.cpp
    V3ParseGrammar.cpp
    V3ParseImp.cpp
    V3ParseLex.cpp
    V3PreProc.cpp
    V3PreShell.cpp
    V3Premit.cpp
    V3ProtectLib.cpp
    V3Randomize.cpp
    V3Reloop.cpp
    V3Sampled.cpp
    V3Sched.cpp
    V3SchedAcyclic.cpp
    V3SchedPartition.cpp
    V3SchedReplicate.cpp
    V3SchedTiming.cpp
    V3SchedTrigger.cpp
    V3SchedUtil.cpp
    V3SchedVirtIface.cpp
    V3Scope.cpp
    V3Scoreboard.cpp
    V3Slice.cpp
    V3Split.cpp
    V3SplitAs.cpp
    V3SplitVar.cpp
    V3StackCount.cpp
    V3Stats.cpp
    V3StatsReport.cpp
    V3String.cpp
    V3Subst.cpp
    V3TSP.cpp
    V3Table.cpp
    V3Task.cpp
    V3ThreadPool.cpp
    V3Timing.cpp
    V3Trace.cpp
    V3TraceDecl.cpp
    V3Tristate.cpp
    V3Udp.cpp
    V3Undriven.cpp
    V3Unknown.cpp
    V3Unroll.cpp
    V3UnrollGen.cpp
    V3VariableOrder.cpp
    V3Waiver.cpp
    V3Width.cpp
    V3WidthCommit.cpp
    V3WidthSel.cpp
)

set(COVERAGE_SOURCES VlcMain.cpp)

# Note about tests:
# VlcMain.cpp #includes the following files:
#  V3Error.cpp, V3String.cpp, V3Os.cpp and VlcTop.cpp

#
# Generated sources and headers for the verilator binary

set(srcdir ${CMAKE_CURRENT_SOURCE_DIR})

file(TO_NATIVE_PATH ${srcdir}/astgen ASTGEN)
file(TO_NATIVE_PATH ${srcdir}/bisonpre BISONPRE)
file(TO_NATIVE_PATH ${srcdir}/flexfix FLEXFIX)
file(TO_NATIVE_PATH ${srcdir}/../bin/verilator_includer VERILATOR_INCLUDER)
file(TO_NATIVE_PATH ${srcdir}/vlcovgen VLCOVGEN)
file(TO_NATIVE_PATH ${srcdir}/config_rev CONFIG_REV)

configure_file(config_package.h.in config_package.h @ONLY)

add_custom_command(
    OUTPUT V3Ast__gen_forward_class_decls.h V3Dfg__gen_forward_class_decls.h
    DEPENDS ./V3Ast.h ${ASTGEN}
    COMMAND ${PYTHON3}
    ARGS
        ${ASTGEN} -I "${srcdir}" --astdef V3AstNodeDType.h --astdef
        V3AstNodeExpr.h --astdef V3AstNodeOther.h --astdef V3AstNodeStmt.h
        --dfgdef V3DfgVertices.h --classes
)
list(
    APPEND
    GENERATED_FILES
    V3Ast__gen_forward_class_decls.h
    V3Dfg__gen_forward_class_decls.h
)
# Output used directly by the `verilator` target

set(verilog_y "${srcdir}/verilog.y")
set(BISON_V3ParseBison_OUTPUT_HEADER
    "${CMAKE_CURRENT_BINARY_DIR}/V3ParseBison.h"
)
set(BISON_V3ParseBison_OUTPUT_SOURCE
    "${CMAKE_CURRENT_BINARY_DIR}/V3ParseBison.c"
)
add_custom_command(
    OUTPUT V3ParseBison.c V3ParseBison.h
    MAIN_DEPENDENCY ./verilog.y
    DEPENDS ${BISONPRE}
    COMMAND ${PYTHON3}
    ARGS
        ${BISONPRE} --yacc "${BISON_EXECUTABLE}" -d -v -o
        "${BISON_V3ParseBison_OUTPUT_SOURCE}" "${verilog_y}"
)
list(APPEND GENERATED_FILES V3ParseBison.c V3ParseBison.h)
# Output used directly by the `verilator` target

set(verilog_l "${srcdir}/verilog.l")
set(FLEX_V3Lexer_pregen_OUTPUTS
    "${CMAKE_CURRENT_BINARY_DIR}/V3Lexer_pregen.yy.cpp"
)
add_custom_command(
    OUTPUT V3Lexer_pregen.yy.cpp
    MAIN_DEPENDENCY ./verilog.l
    DEPENDS ${BISON_V3ParseBison_OUTPUT_HEADER} ${HEADERS}
    COMMAND ${FLEX_EXECUTABLE}
    ARGS ${LFLAGS} -o "${FLEX_V3Lexer_pregen_OUTPUTS}" "${verilog_l}"
)
# Output used by another command

set(FLEX_V3Lexer_OUTPUTS ${CMAKE_CURRENT_BINARY_DIR}/V3Lexer.yy.cpp)
add_custom_command(
    OUTPUT V3Lexer.yy.cpp
    MAIN_DEPENDENCY ${FLEX_V3Lexer_pregen_OUTPUTS}
    DEPENDS ${FLEXFIX}
    COMMAND ${PYTHON3}
    ARGS
        ${FLEXFIX} V3Lexer < "$<SHELL_PATH:${FLEX_V3Lexer_pregen_OUTPUTS}>" >
        "$<SHELL_PATH:${FLEX_V3Lexer_OUTPUTS}>"
)
add_custom_target(
    V3Lexer_yy_cpp${CMAKE_BUILD_TYPE}
    DEPENDS ${FLEX_V3Lexer_OUTPUTS}
)
# Output included by another source file

set(FLEX_V3PreLex_pregen_OUTPUTS
    ${CMAKE_CURRENT_BINARY_DIR}/V3PreLex_pregen.yy.cpp
)
add_custom_command(
    OUTPUT V3PreLex_pregen.yy.cpp
    MAIN_DEPENDENCY ./V3PreLex.l
    DEPENDS ${HEADERS}
    COMMAND ${FLEX_EXECUTABLE}
    ARGS ${LFLAGS} -o "${FLEX_V3PreLex_pregen_OUTPUTS}" "${srcdir}/V3PreLex.l"
)
# Output used by another command

set(FLEX_V3PreLex_OUTPUTS ${CMAKE_CURRENT_BINARY_DIR}/V3PreLex.yy.cpp)
add_custom_command(
    OUTPUT V3PreLex.yy.cpp
    MAIN_DEPENDENCY ${FLEX_V3PreLex_pregen_OUTPUTS}
    DEPENDS ${FLEXFIX}
    COMMAND ${PYTHON3}
    ARGS
        ${FLEXFIX} V3PreLex < "$<SHELL_PATH:${FLEX_V3PreLex_pregen_OUTPUTS}>" >
        "$<SHELL_PATH:${FLEX_V3PreLex_OUTPUTS}>"
)
add_custom_target(
    V3PreLex_yy_cpp${CMAKE_BUILD_TYPE}
    DEPENDS ${FLEX_V3PreLex_OUTPUTS}
)
# Output included by another source file

set(gitHead ${srcdir}/../.git/logs/HEAD)
if(NOT EXISTS ${githead})
    set(gitHead "")
endif()
add_custom_command(
    OUTPUT config_rev.h
    MAIN_DEPENDENCY ${gitHead}
    DEPENDS ${CONFIG_REV}
    COMMAND ${PYTHON3}
    ARGS
        ${CONFIG_REV} "${srcdir}" >
        "$<SHELL_PATH:${CMAKE_CURRENT_BINARY_DIR}/config_rev.h>"
)
list(APPEND GENERATED_FILES config_rev.h)
# Output used directly by the `verilator` target

set(ASTGENERATED_NAMES V3Const)

foreach(astgen_name ${ASTGENERATED_NAMES})
    add_custom_command(
        OUTPUT ${astgen_name}__gen.cpp
        MAIN_DEPENDENCY ${astgen_name}.cpp
        DEPENDS ${ASTGEN} V3Ast.h
        COMMAND ${PYTHON3}
        ARGS
            ${ASTGEN} -I "${srcdir}" --astdef V3AstNodeDType.h --astdef
            V3AstNodeExpr.h --astdef V3AstNodeOther.h --astdef V3AstNodeStmt.h
            --dfgdef V3DfgVertices.h ${astgen_name}.cpp
    )
    list(APPEND GENERATED_FILES ${astgen_name}__gen.cpp)
endforeach()

#
# Set up the Coverage build type

addbuildtype(DEBUG COVERAGE)

# This regenerates include/verilated_cov_key.h in the source tree.
# It is a custom_target, not custom_command, because vlcovgen.d is
# a phony target (it doesn't exist as a file).
add_custom_target(
    vlcovgen.d${CMAKE_BUILD_TYPE}
    DEPENDS ../include/verilated_cov_key.h ${VLCOVGEN}
    COMMENT "Updating include/verilated_cov_key.h"
    COMMAND ${PYTHON3} ${VLCOVGEN} --srcdir ${srcdir}
)

#
# Set up the verilator binary target

set(verilator verilator${CMAKE_BUILD_TYPE})

=== test_regress/Makefile ===
#*****************************************************************************
#
# DESCRIPTION: Verilator Example: Makefile for inside source directory
#
# This calls the object directory makefile.  That allows the objects to
# be placed in the "current directory" which simplifies the Makefile.
#
# Copyright 2003-2025 by Wilson Snyder. This program is free software; you
# can redistribute it and/or modify it under the terms of either the GNU
# Lesser General Public License Version 3 or the Perl Artistic License
# Version 2.0.
# SPDX-License-Identifier: LGPL-3.0-only OR Artistic-2.0
#
#****************************************************************************/

default: test

# This must point to the root of the VERILATOR kit
VERILATOR_ROOT ?= $(shell pwd)/..
export VERILATOR_ROOT

# Pick up PERL and other variable settings
include $(VERILATOR_ROOT)/include/verilated.mk

######################################################################

ifneq ($(VCS_HOME),)
#Default to off, even with vcs; not all tests are ensured to be working
#PRODUCTS += --vcs
endif

ifneq ($(NC_ROOT),)
#Default to off, even with vcs; not all tests are ensured to be working
#PRODUCTS += --nc
endif

# Run tests in parallel.
ifeq ($(CFG_WITH_LONGTESTS),yes)
  DRIVER_FLAGS ?= -j 0 --quiet --rerun
endif

.SUFFIXES:

######################################################################

SCENARIOS ?= --vlt --vltmt --dist
DRIVER_HASHSET ?=

.PHONY: test
test:
	$(PYTHON3) driver.py $(DRIVER_FLAGS) $(SCENARIOS) $(DRIVER_HASHSET)

######################################################################

vcs:
	$(PYTHON3) driver.py $(DRIVER_FLAGS) --vcs --stop

######################################################################

nc:
	$(PYTHON3) driver.py $(DRIVER_FLAGS) --nc --stop

######################################################################

vlt:
	$(PYTHON3) driver.py $(DRIVER_FLAGS) --vlt --stop

vltmt:
	$(PYTHON3) driver.py $(DRIVER_FLAGS) --vltmt --stop

######################################################################

random:
	$(PYTHON3) driver.py $(DRIVER_FLAGS) --optimize : --stop

random_forever:
	while ( VERILATOR_NO_DEBUG=1 CPPFLAGS_ADD=-Wno-error $(MAKE) random ) ; do \
		echo ; \
	done

#######################################################################
# Informational - used by some tests

print-cxx-version:
	$(CXX) --version

######################################################################
maintainer-copy::
clean mostlyclean distclean maintainer-clean::
	-rm -rf obj_* simv* simx* csrc cov_work INCA_libs *.log *.key logs vc_hdrs.h
	-rm -rf t/obj_* t/__pycache__

distclean::
	-rm -rf snapshot

######################################################################
# Generated code snapshot and diff for tests

# Can be overridden for multiple snapshots
TEST_SNAP_DIR ?= snapshot

# Command to diff directories
TEST_DIFF_TOOL ?= $(if $(shell which icdiff), icdiff -N -r, diff -r)

TEST_SNAP_IGNORE := \
  *.status *.log *.dat *.d *.o *.a *.so *stats*.txt *.html *.includecache \
  *.out *.fst *.fst.vcd *.tree *.tree*.json *.dot *.csv *.xml *.hash \
  *.cmake gmon.out.* CMakeFiles profile_exec.vcd *line-coverage*.txt \
  profile.vlt *linkdot.txt *linkcells.txt *.log.sort *.vpp *.sarif \
  t_flag_debugi9 t_flag_decorations_node t_flag_runtime_debug t_mod_empty \
  t_pgo_threads t_pgo_threads_hier t_trace_ub_misaligned_address \

define TEST_SNAP_template
mkdir -p $(TEST_SNAP_DIR)
rm -rf $(TEST_SNAP_DIR)/obj_$(1)
cp -r obj_$(1) $(TEST_SNAP_DIR)/
find $(TEST_SNAP_DIR)/obj_$(1) \( $(TEST_SNAP_IGNORE:%=-name "%" -o) \
  -type f -executable \) -prune | xargs rm -r
endef

.PHONY: test-snap
test-snap:
	$(call TEST_SNAP_template,vlt)
	$(call TEST_SNAP_template,vltmt)
	$(call TEST_SNAP_template,dist)

.PHONY: impl-test-diff
impl-test-diff:
	$(TEST_DIFF_TOOL) $(TEST_SNAP_DIR)/obj_vlt   obj_vlt || true
	$(TEST_DIFF_TOOL) $(TEST_SNAP_DIR)/obj_vltmt obj_vltmt || true
	$(TEST_DIFF_TOOL) $(TEST_SNAP_DIR)/obj_dist  obj_dist || true

.PHONY: test-diff
test-diff:
	$(MAKE) impl-test-diff | grep -v "Only in obj_" \
	| $$(git config --default less --global --get core.pager)

=== examples/cmake_hello_sc/CMakeLists.txt ===
######################################################################
#
# DESCRIPTION: Verilator CMake Example: Small CMakeLists.txt with SystemC
#
# This is an example cmake script to build a verilog to SystemC project
# using CMake and Verilator.
#
# This file ONLY is placed under the Creative Commons Public Domain, for
# any use, without warranty, 2020 by Wilson Snyder.
# SPDX-License-Identifier: CC0-1.0
#
######################################################################

# This example builds the tracing_sc example using CMake
# To use it, run the following:

# cd /path/to/verilator/examples/cmake_sc
# rm -rf build && mkdir build && cd build
# cmake ..
# cmake --build .

cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0074 NEW)
project(cmake_hello_sc CXX)

find_package(verilator HINTS $ENV{VERILATOR_ROOT} ${VERILATOR_ROOT})
if(NOT verilator_FOUND)
    message(
        FATAL_ERROR
        "Verilator was not found. Either install it, or set the VERILATOR_ROOT environment variable"
    )
endif()

# SystemC dependencies
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Find SystemC using SystemC's CMake integration
find_package(SystemCLanguage QUIET)

# Create a new executable target that will contain all your sources
add_executable(example ../make_hello_sc/sc_main.cpp)
target_compile_features(example PUBLIC cxx_std_14)

set_property(TARGET example PROPERTY CXX_STANDARD ${SystemC_CXX_STANDARD})

# Add the Verilated circuit to the target
verilate(example SYSTEMC
  INCLUDE_DIRS "../make_hello_sc"
  SOURCES ../make_hello_sc/top.v
)

verilator_link_systemc(example)

=== examples/cmake_protect_lib/Makefile ===
######################################################################
#
# DESCRIPTION: Verilator CMake example usage
#
# This file shows usage of the CMake script.
# This makefile is here for testing the examples and should
# generally not be added to a CMake project.
#
# This file ONLY is placed under the Creative Commons Public Domain, for
# any use, without warranty, 2020 by Wilson Snyder.
# SPDX-License-Identifier: CC0-1.0
#
######################################################################

######################################################################
# Set up variables

# If $VERILATOR_ROOT isn't in the environment, we assume it is part of a
# package install, and verilator is in your path. Otherwise find the
# binary relative to $VERILATOR_ROOT (such as when inside the git sources).

ifeq ($(VERILATOR_ROOT),)
  VERILATOR = verilator
  VERILATOR_COVERAGE = verilator_coverage
else
  export VERILATOR_ROOT
  VERILATOR = $(VERILATOR_ROOT)/bin/verilator
  VERILATOR_COVERAGE = $(VERILATOR_ROOT)/bin/verilator_coverage
endif
######################################################################

# Check if CMake is installed and of correct version
ifeq ($(shell which cmake),)
  TARGET := nocmake
else
  CMAKE_VERSION := $(shell cmake --version | grep -o '[0-9][.0-9]\+')
  CMAKE_MAJOR := $(shell echo $(CMAKE_VERSION) | cut -f1 -d.)
  CMAKE_MINOR := $(shell echo $(CMAKE_VERSION) | cut -f2 -d.)
  CMAKE_GT_3_8 := $(shell [ $(CMAKE_MAJOR) -gt 3 -o \( $(CMAKE_MAJOR) -eq 3 -a $(CMAKE_MINOR) -ge 8 \) ] && echo true)
  ifeq ($(CMAKE_GT_3_8),true)
    TARGET := run
  else
    TARGET := oldcmake
  endif
endif

default: $(TARGET)

run:
	@echo
	@echo "-- Verilator CMake protect_lib example"

	@echo
	@echo "-- VERILATE ----------------"
	mkdir -p build && cd build && cmake ..

	@echo
	@echo "-- BUILD -------------------"
	cmake --build build -j

	@echo
	@echo "-- RUN ---------------------"
	build/example

	@echo
	@echo "-- DONE --------------------"
	@echo

clean mostlyclean distclean maintainer-clean:
	@rm -rf build logs

nocmake:
	@echo
	@echo "%Skip: CMake has not been found"
	@echo

oldcmake:
	@echo
	@echo "%Skip: CMake version is too old (need at least 3.8)"
	@echo

=== examples/cmake_tracing_sc/Makefile ===
######################################################################
#
# DESCRIPTION: Verilator CMake example usage
#
# This file shows usage of the CMake script.
# This makefile is here for testing the examples and should
# generally not be added to a CMake project.
#
# This file ONLY is placed under the Creative Commons Public Domain, for
# any use, without warranty, 2020 by Wilson Snyder.
# SPDX-License-Identifier: CC0-1.0
#
######################################################################

######################################################################
# Set up variables

# If $VERILATOR_ROOT isn't in the environment, we assume it is part of a
# package install, and verilator is in your path. Otherwise find the
# binary relative to $VERILATOR_ROOT (such as when inside the git sources).

ifeq ($(VERILATOR_ROOT),)
  VERILATOR = verilator
  VERILATOR_COVERAGE = verilator_coverage
else
  export VERILATOR_ROOT
  VERILATOR = $(VERILATOR_ROOT)/bin/verilator
  VERILATOR_COVERAGE = $(VERILATOR_ROOT)/bin/verilator_coverage
endif
######################################################################

# Check if CMake is installed and of correct version
ifeq ($(shell which cmake),)
  TARGET := nocmake
else
  CMAKE_VERSION := $(shell cmake --version | grep -o '[0-9][.0-9]\+')
  CMAKE_MAJOR := $(shell echo $(CMAKE_VERSION) | cut -f1 -d.)
  CMAKE_MINOR := $(shell echo $(CMAKE_VERSION) | cut -f2 -d.)
  CMAKE_GT_3_8 := $(shell [ $(CMAKE_MAJOR) -gt 3 -o \( $(CMAKE_MAJOR) -eq 3 -a $(CMAKE_MINOR) -ge 8 \) ] && echo true)
  ifneq ($(CMAKE_GT_3_8),true)
    TARGET := oldcmake
  else
    # Check if SC exists via a verilator call (empty if not)
    SYSTEMC_EXISTS := $(shell $(VERILATOR) --get-supported SYSTEMC)

    # Test whether SystemC is installed with CMake support
    # This will print a CMake error about processing arguments that can (currently) be ignored.
    ifneq (,$(SYSTEMC_EXISTS))
      FINDSC := $(shell mkdir -p build && cd build && cmake --find-package -DNAME=SystemCLanguage -DCMAKE_USE_PTHREADS_INIT=ON -DCOMPILER_ID=GNU -DLANGUAGE=CXX -DMODE=EXIST -DThreads_FOUND=ON)
      ifneq (,$(findstring SystemCLanguage found,$(FINDSC)))
        SYSTEMC_SET := true
      endif
    endif

    ifeq ($(SYSTEMC_SET), true)
      TARGET := run
    else
      TARGET := nosc
    endif
  endif
endif

default: $(TARGET)

run:
	@echo
	@echo "-- Verilator CMake SystemC tracing example"

	@echo
	@echo "-- VERILATE ----------------"
	mkdir -p build && cd build && cmake ..

	@echo
	@echo "-- BUILD -------------------"
	cmake --build build -j

	@echo
	@echo "-- RUN ---------------------"
	@mkdir -p logs
	build/example +trace_vcd

	@echo
	@echo "-- COVERAGE ----------------"
	$(VERILATOR_COVERAGE) --annotate logs/annotated logs/coverage.dat

	@echo
	@echo "-- DONE --------------------"
	@echo "To see waveforms, open vlt_dump.vcd in a waveform viewer"
	@echo

clean mostlyclean distclean maintainer-clean:
	@rm -rf build logs

nocmake:
	@echo
	@echo "%Skip: CMake has not been found"
	@echo

oldcmake:
	@echo
	@echo "%Skip: CMake version is too old (need at least 3.8)"
	@echo

nosc:
	@echo
	@echo "%Skip: CMake could not find SystemC."
	@echo "% Make sure that either:"
	@echo "% - The environment variables SYSTEMC_INCLUDE and SYSTEMC_LIBDIR are exported."
	@echo "% - Or, the environment variable SYSTEMC_ROOT is exported."
	@echo "% - Or, The environment variable SYSTEMC is exported."
	@echo "% - Or, if the SystemC installation provides CMake support,"
	@echo "%   that its installation prefix is in CMAKE_PREFIX_PATH."
	@echo "% Also that the C++ standard of the SystemC library is the same as this example."
	@echo "% Please see the Verilator documentation's CMake section for more information."
	@echo

=== test_regress/t/t_hier_block_cmake/CMakeLists.txt ===
######################################################################
#
# DESCRIPTION: CMake script for t_hier_block_cmake
#
# Copyright 2003-2024 by Wilson Snyder. This program is free software; you
# can redistribute it and/or modify it under the terms of either the GNU
# Lesser General Public License Version 3 or the Perl Artistic License
# Version 2.0.
# SPDX-License-Identifier: LGPL-3.0-only OR Artistic-2.0
#
######################################################################

cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0074 NEW)
project (t_hier_block_cmake)

find_package(verilator REQUIRED)

add_executable(t_hier_block_cmake  main.cpp ../t_hier_block.cpp)

if(TEST_THREADS)
    set(VERILATOR_OPTIONS "${VERILATOR_OPTIONS}" --threads ${TEST_THREADS})
endif()
set(VERILATOR_OPTIONS "${VERILATOR_OPTIONS}" --hierarchical --stats --CFLAGS "-pipe -DCPP_MACRO=cplusplus")

verilate(t_hier_block_cmake VERILATOR_ARGS ${VERILATOR_OPTIONS} SOURCES
    ../t_hier_block.v )

=== debian/changelog ===
verilator (5.042-1) unstable; urgency=medium

  * [329aeda] New upstream version 5.042
  * [b0d6477] Drop redundant Rules-Requires-Root field
  * [9da26a5] Drop fix-blhc.patch, applied upstream

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 05 Nov 2025 13:11:52 +0100

=== debian/control ===
Source: verilator
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders:
 أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>,
Build-Depends:
 bison,
 debhelper-compat (= 13),
 dh-sequence-sphinxdoc,
 flex,
 latexmk,
 libfl-dev,
 libsystemc-dev [amd64 arm64 i386 kfreebsd-any],
 help2man,
 python3,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 tex-gyre,
 texlive-latex-extra,
 python3-distro,
 architecture-is-64-bit,
Standards-Version: 4.7.2
Homepage: http://www.veripool.org/wiki/verilator
Vcs-Git: https://salsa.debian.org/electronics-team/verilator.git
Vcs-Browser: https://salsa.debian.org/electronics-team/verilator

Package: verilator
Architecture: any
Depends:
 python3,
 g++,
 ccache,
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Recommends:
 libsystemc-dev [amd64 arm64 i386 kfreebsd-any],
Suggests:
 gtkwave,
Description: fast free Verilog simulator
 Verilator is the fastest free Verilog HDL simulator, and beats many commercial
 simulators. It compiles synthesizable Verilog (not test-bench code!), plus
 some PSL, SystemVerilog and Synthesis assertions into C++ or SystemC code.
 It is designed for large projects where fast simulation performance is of
 primary concern, and is especially well suited to generate executable models
 of CPUs for embedded software design teams.

## verilator 5.044

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 #*****************************************************************************
 #
-# Copyright 2003-2025 by Wilson Snyder. This program is free software; you
+# Copyright 2003-2026 by Wilson Snyder. This program is free software; you
 # can redistribute it and/or modify it under the terms of either the GNU
 # Lesser General Public License Version 3 or the Perl Artistic License
 # Version 2.0.
@@ -16,7 +16,7 @@
 cmake_policy(SET CMP0091 NEW) # Use MSVC_RUNTIME_LIBRARY to select the runtime
 project(
     Verilator
-    VERSION 5.042
+    VERSION 5.044
     HOMEPAGE_URL https://verilator.org
     LANGUAGES CXX
 )

=== docs/Makefile ===
#*****************************************************************************
# DESCRIPTION: Verilator documentation: Makefile pre-configure version
#
# This file is part of Verilator.
#
# Code available from: https://verilator.org
#
# Copyright 2003-2026 by Wilson Snyder. This program is free software; you
# can redistribute it and/or modify it under the terms of either the GNU
# Lesser General Public License Version 3 or the Perl Artistic License
# Version 2.0.
# SPDX-License-Identifier: LGPL-3.0-only OR Artistic-2.0
#
######################################################################
#
# This file is intended only to be called from the top-level Verilator Makefile.

RST2HTML = rst2html
PYTHON3 = python3
DOXYGEN = doxygen
SPHINXBUILD ?= sphinx-build

SOURCEDIR = guide
BUILDDIR = _build

SPHINXOPTS ?= -c guide -j 4
ifneq ($(VERILATOR_ANALYTICS_ID),)
  SPHINXOPTS += -D html_theme_options.analytics_id=$(VERILATOR_ANALYTICS_ID)
endif

######################################################################

.SUFFIXES:

default:
	@echo "error: make not supported here, run 'make docs' from Verilator top-level"

######################################################################
# Intermediate rules

vl-extract: ../bin/verilator ../Changes
	ln -sf ../spelling.txt guide/spelling.txt
	mkdir -p _build/gen
	$(PYTHON3) bin/vl_sphinx_extract ../bin/verilator
	sed 's/`/\&96;/g' < ../Changes > _build/gen/Changes

######################################################################
# HTML

server: html
	cd _build/html && $(PYTHON3) -m http.server

%.html: %.rst
	$(RST2HTML) $< $@

######################################################################
# PDF

.PHONY: verilator.pdf

verilator.pdf: pdf
pdf:
	$(MAKE) vl-extract
	$(MAKE) latex
	$(PYTHON3) bin/vl_sphinx_fix _build
	$(MAKE) -C _build/latex
	cp _build/latex/verilator.pdf ..

######################################################################

html latex linkcheck::
	$(MAKE) vl-extract
	$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)
	$(PYTHON3) bin/vl_sphinx_fix _build

spelling::
	$(MAKE) vl-extract
	$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)
	sort -o guide/spelling.txt guide/spelling.txt

help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)

clean mostlyclean distclean maintainer-clean::
	rm -rf _build
	rm -f $(SCRIPTS) *.tmp
	rm -f *.aux *.cp *.cps *.dvi *.fn *.fns *.ky *.kys *.log
	rm -f *.pg *.pgs *.toc *.tp *.tps *.vr *.vrs *.idx
	rm -f *.ev *.evs *.ov *.ovs *.cv *.cvs *.ma *.mas
	rm -f *.tex
	rm -f guide/spelling.txt

distclean maintainer-clean::
	rm -f *.info* *.1 *.html *.pdf $(INFOS)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 #*****************************************************************************
 #
-# Copyright 2003-2025 by Wilson Snyder. This program is free software; you
+# Copyright 2003-2026 by Wilson Snyder. This program is free software; you
 # can redistribute it and/or modify it under the terms of either the GNU
 # Lesser General Public License Version 3 or the Perl Artistic License
 # Version 2.0.
@@ -43,6 +43,7 @@
     V3ActiveTop.h
     V3Assert.h
     V3AssertPre.h
+    V3AssertProp.h
     V3Ast.h
     V3AstAttr.h
     V3AstInlines.h
@@ -113,6 +114,7 @@
     V3Hasher.h
     V3HierBlock.h
     V3Inline.h
+    V3InlineCFuncs.h
     V3Inst.h
     V3InstrCount.h
     V3Interface.h
@@ -122,6 +124,7 @@
     V3LifePost.h
     V3LinkCells.h
     V3LinkDot.h
+    V3LinkDotIfaceCapture.h
     V3LinkInc.h
     V3LinkJump.h
     V3LinkLValue.h
@@ -155,6 +158,7 @@
     V3PreShell.h
     V3Premit.h
     V3ProtectLib.h
+    V3RandSequence.h
     V3Randomize.h
     V3Reloop.h
     V3Rtti.h
@@ -207,6 +211,7 @@
     V3ActiveTop.cpp
     V3Assert.cpp
     V3AssertPre.cpp
+    V3AssertProp.cpp
     V3Ast.cpp
     V3AstNodes.cpp
     V3Begin.cpp
@@ -283,13 +288,16 @@
     V3Hasher.cpp
     V3HierBlock.cpp
     V3Inline.cpp
+    V3InlineCFuncs.cpp
     V3Inst.cpp
     V3InstrCount.cpp
     V3Interface.cpp
+    V3LibMap.cpp
     V3Life.cpp
     V3LifePost.cpp
     V3LinkCells.cpp
     V3LinkDot.cpp
+    V3LinkDotIfaceCapture.cpp
     V3LinkInc.cpp
     V3LinkJump.cpp
     V3LinkLValue.cpp
@@ -317,6 +325,7 @@
     V3PreShell.cpp
     V3Premit.cpp
     V3ProtectLib.cpp
+    V3RandSequence.cpp
     V3Randomize.cpp
     V3Reloop.cpp
     V3Sampled.cpp
@@ -389,8 +398,7 @@
         --dfgdef V3DfgVertices.h --classes
 )
 list(
-    APPEND
-    GENERATED_FILES
+    APPEND GENERATED_FILES
     V3Ast__gen_forward_class_decls.h
     V3Dfg__gen_forward_class_decls.h
 )
@@ -514,12 +522,3 @@
 # a phony target (it doesn't exist as a file).
 add_custom_target(
     vlcovgen.d${CMAKE_BUILD_TYPE}
-    DEPENDS ../include/verilated_cov_key.h ${VLCOVGEN}
-    COMMENT "Updating include/verilated_cov_key.h"
-    COMMAND ${PYTHON3} ${VLCOVGEN} --srcdir ${srcdir}
-)
-
-#
-# Set up the verilator binary target
-
-set(verilator verilator${CMAKE_BUILD_TYPE})

=== test_regress/CMakeLists.txt ===
######################################################################
#
# DESCRIPTION: CMake script for regression tests
#
# This CMake file is meant to be consumed by regression tests.
#
# Copyright 2003-2026 by Wilson Snyder. This program is free software; you
# can redistribute it and/or modify it under the terms of either the GNU
# Lesser General Public License Version 3 or the Perl Artistic License
# Version 2.0.
# SPDX-License-Identifier: LGPL-3.0-only OR Artistic-2.0
#
######################################################################

cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0074 NEW)
set(TEST_REQUIRED_VARS
    NAME
    CSOURCES
    OPT_FAST
    OPT_GLOBAL
    VERILATOR_ROOT
    VERILATOR_ARGS
    VERILATOR_SOURCES
    SYSTEMC
    VERBOSE
    VERILATION
)
foreach(var ${TEST_REQUIRED_VARS})
    if(NOT DEFINED TEST_${var})
        message(
            FATAL_ERROR
            "TEST_${var} not defined. This CMakeLists.txt file is meant to be run by driver.py."
        )
    endif()
endforeach()

project("${TEST_NAME}")

if(TEST_VERBOSE)
    add_definitions(-DTEST_VERBOSE=1)
endif()

separate_arguments(TEST_VERILATOR_ARGS UNIX_COMMAND "${TEST_VERILATOR_ARGS}")

# filter out empty arguments
list(FILTER TEST_VERILATOR_ARGS EXCLUDE REGEX "$^")

set(TEST_PREFIX ${TEST_NAME})

# If --ARG <val> is present, set OUT = <val>
function(getarg LST ARG OUT)
    list(FIND ${LST} ${ARG} _INDEX)
    if(NOT _INDEX EQUAL -1)
        list(REMOVE_AT ${LST} ${_INDEX})
        list(GET ${LST} ${_INDEX} VAL)
        set(${OUT} ${VAL} PARENT_SCOPE)
    endif()
endfunction()

# Normalise -- to -
string(
    REGEX REPLACE
    "(^|;)--"
    "\\1-"
    TEST_VERILATOR_ARGS_NORM
    "${TEST_VERILATOR_ARGS}"
)

getarg(TEST_VERILATOR_ARGS_NORM "-prefix" TEST_PREFIX)
getarg(TEST_VERILATOR_ARGS_NORM "-threads" TEST_THREADS)
getarg(TEST_VERILATOR_ARGS_NORM "-trace-threads" TEST_TRACE_THREADS)

# Strip unwanted args with 1 parameter
string(
    REGEX REPLACE
    "(^|;)--?(Mdir|make|prefix|threads|trace-threads);[^;]*"
    ""
    TEST_VERILATOR_ARGS
    "${TEST_VERILATOR_ARGS}"
)
# Strip unwanted args
string(
    REGEX REPLACE
    "(^|;)--?(sc|cc)"
    ""
    TEST_VERILATOR_ARGS
    "${TEST_VERILATOR_ARGS}"
)

separate_arguments(
    TEST_VERILATOR_SOURCES
    UNIX_COMMAND
    "${TEST_VERILATOR_SOURCES}"
)
# filter out empty sources
list(FILTER TEST_VERILATOR_SOURCES EXCLUDE REGEX "$^")

find_package(verilator REQUIRED HINTS ${TEST_VERILATOR_ROOT})

set(verilate_ARGS MAIN)
if(TEST_PREFIX)
    list(APPEND verilate_ARGS PREFIX ${TEST_PREFIX})
endif()
if(TEST_OPT_FAST)
    list(APPEND verilate_ARGS OPT_FAST ${TEST_OPT_FAST})
endif()
if(TEST_OPT_GLOBAL)
    list(APPEND verilate_ARGS OPT_GLOBAL ${TEST_OPT_GLOBAL})
endif()
if(TEST_THREADS)
    list(APPEND verilate_ARGS THREADS ${TEST_THREADS})
endif()
if(TEST_TRACE_THREADS)
    list(APPEND verilate_ARGS TRACE_THREADS ${TEST_TRACE_THREADS})
endif()
if(TEST_SYSTEMC)
    list(APPEND verilate_ARGS SYSTEMC)
endif()

set(TARGET_NAME "V${TEST_NAME}")

add_executable(${TARGET_NAME} ${TEST_CSOURCES})

if(TEST_VERILATION)
    verilate(${TARGET_NAME} ${verilate_ARGS}
             VERILATOR_ARGS ${TEST_VERILATOR_ARGS}
             DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
             SOURCES ${TEST_VERILATOR_SOURCES}
    )
endif()

if(TEST_SYSTEMC)
    verilator_link_systemc("${TARGET_NAME}")
endif()

string(TOUPPER "${TEST_NAME}" TEST_NAME_UC)

target_compile_definitions(
    ${TARGET_NAME}
    PRIVATE
        "TEST_OBJ_DIR=${CMAKE_CURRENT_BINARY_DIR}"
        "VM_PREFIX=${TEST_PREFIX}"
        "VM_PREFIX_INCLUDE=<${TEST_PREFIX}.h>"
        "${TEST_NAME_UC}"
)

=== test_regress/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # This calls the object directory makefile.  That allows the objects to
 # be placed in the "current directory" which simplifies the Makefile.
 #
-# Copyright 2003-2025 by Wilson Snyder. This program is free software; you
+# Copyright 2003-2026 by Wilson Snyder. This program is free software; you
 # can redistribute it and/or modify it under the terms of either the GNU
 # Lesser General Public License Version 3 or the Perl Artistic License
 # Version 2.0.

=== debian/changelog ===
verilator (5.044-1) unstable; urgency=medium

  * [f583940] New upstream version 5.044
  * [ea40216] d/control: bump standards version to 4.7.3
  * [12a35b8] Update copyright years
  * [3e31295] d/control: drop redundant Priority: optional field
  * [aa73ef3] d/control: remove kfreebsd-any arch spec
    it has been recently removed from dpkg

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 28 Jan 2026 20:38:17 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: verilator
 Section: electronics
-Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders:
  أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>,
@@ -11,7 +10,7 @@
  flex,
  latexmk,
  libfl-dev,
- libsystemc-dev [amd64 arm64 i386 kfreebsd-any],
+ libsystemc-dev [amd64 arm64 i386],
  help2man,
  python3,
  python3-sphinx,
@@ -20,7 +19,7 @@
  texlive-latex-extra,
  python3-distro,
  architecture-is-64-bit,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: http://www.veripool.org/wiki/verilator
 Vcs-Git: https://salsa.debian.org/electronics-team/verilator.git
 Vcs-Browser: https://salsa.debian.org/electronics-team/verilator
@@ -38,7 +37,7 @@
 Built-Using:
  ${sphinxdoc:Built-Using},
 Recommends:
- libsystemc-dev [amd64 arm64 i386 kfreebsd-any],
+ libsystemc-dev [amd64 arm64 i386],
 Suggests:
  gtkwave,
 Description: fast free Verilog simulator
